routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

Auth::routes();

Route::get('/jenis', 'HomeController@jenis')->name('jenis');

Route::name('Auth.')->namespace('Auth')->prefix('auth')->group(function () {

	Route::name('Admin.')->prefix('admin')->group(function () {
		Route::post('store', 'AdminsController@store')->name('store');
	});
	
	Route::post('adminLogin', 'LoginController@adminLogin')->name('adminLogin');

});

Route::group(['middleware' => 'auth:admin'], function () {

	Route::name('Admin.')->namespace('Admin')->prefix('admin')->group(function () {

		Route::name('Dashboard.')->namespace('Dashboard')->prefix('dashboard')->group(function () {
			Route::get('/', 'DashboardController@index')->name('index');
		});

		Route::name('Master.')->namespace('Master')->prefix('master')->group(function () {

			#Jenis
			Route::name('Jenis.')->namespace('Jenis')->prefix('jenis')->group(function () {
				Route::get('/', 'JenisController@index')->name('index');
				Route::get('/getdata', 'JenisController@getdata')->name('getdata');
				Route::get('/edit/{id}', 'JenisController@edit')->name('edit');
				Route::post('store', 'JenisController@store')->name('store');
				Route::post('destroy', 'JenisController@destroy')->name('destroy');
			});

			#Grade
			Route::name('Grade.')->namespace('Grade')->prefix('grade')->group(function () {
				Route::get('/', 'GradeController@index')->name('index');
				Route::get('/getdata', 'GradeController@getdata')->name('getdata');
				Route::get('/edit/{id}', 'GradeController@edit')->name('edit');
				Route::post('store', 'GradeController@store')->name('store');
				Route::post('destroy', 'GradeController@destroy')->name('destroy');
			});

			#Pengguna
			Route::name('Pengguna.')->namespace('Pengguna')->prefix('pengguna')->group(function () {
				Route::get('/', 'PenggunaController@index')->name('index');
				Route::get('/getdata', 'PenggunaController@getdata')->name('getdata');
				Route::get('/edit/{id}', 'PenggunaController@edit')->name('edit');
				Route::get('/show/{id}', 'PenggunaController@show')->name('show');
				Route::post('store', 'PenggunaController@store')->name('store');
				Route::post('destroy', 'PenggunaController@destroy')->name('destroy');
			});

			#Bank
			Route::name('Bank.')->namespace('Bank')->prefix('bank')->group(function () {
				Route::get('/', 'BankController@index')->name('index');
				Route::get('/getdata', 'BankController@getdata')->name('getdata');
				Route::get('/edit/{id}', 'BankController@edit')->name('edit');
				Route::post('store', 'BankController@store')->name('store');
			});

		});

		Route::name('Katalog.')->namespace('Katalog')->prefix('katalog')->group(function () {

			#
			Route::name('Produk.')->namespace('Produk')->prefix('produk')->group(function () {
				Route::get('/data/{id}', 'ProdukController@index')->name('index');
				Route::get('/getdata/{id}', 'ProdukController@getdata')->name('getdata');
				Route::get('/edit/{id}', 'ProdukController@edit')->name('edit');
				Route::post('store', 'ProdukController@store')->name('store');
				Route::post('destroy', 'ProdukController@destroy')->name('destroy');
			});

		});

		#Jenis
		Route::name('Transaksi.')->namespace('Transaksi')->prefix('transaksi')->group(function () {
			Route::get('/', 'TransaksiController@index')->name('index');
			Route::get('/getdata', 'TransaksiController@getdata')->name('getdata');
			Route::get('/edit/{id}', 'TransaksiController@edit')->name('edit');
			Route::post('store', 'TransaksiController@store')->name('store');
		});

	});

});

app/Models/Master/Bank.php
<?php

namespace App\Models\Master;

use Illuminate\Database\Eloquent\Model;

class Bank extends Model
{
    protected $table = 'bank';

    protected $fillable = [
        'nama_bank','no_rek','status'
    ];
}

app/Models/Master/Grade.php
<?php

namespace App\Models\Master;

use Illuminate\Database\Eloquent\Model;

class Grade extends Model
{
    protected $table = 'grade';

    protected $fillable = [
        'nama_grade','deskripsi_grade','jenis_id'
    ];

    public function jenis(){
    	return $this->belongsTo('App\Models\Master\Jenis','jenis_id','id');
    }
}

app/Models/Master/Jenis.php
<?php

namespace App\Models\Master;

use Illuminate\Database\Eloquent\Model;

class Jenis extends Model
{
    protected $table = 'jenis';

    protected $fillable = [
        'nama_jenis'
    ];
}

app/Models/Master/User.php
<?php

namespace App\Models\Master;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */

    protected $table = 'users';

    protected $fillable = [
        'name', 'email', 'password','foto','no_telp'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/Admin/Master/Bank/BankController.php
<?php

namespace App\Http\Controllers\Admin\Master\Bank;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Master\Bank;
use DataTables;

class BankController extends Controller
{
    public function index()
    {
        return view('admin.master.bank.index');
    }

    public function getdata()
    {
        $data = Bank::orderby('nama_bank','asc')->get();
        return DataTables::of($data)
            ->addIndexColumn()
            ->addColumn('action', function ($row) {
                $btn = '<button type="button" class="btn btn-warning btn-sm Edit" data-id="' . $row->id . '">
                            <i class="material-icons">mode_edit_outline</i>
                        </button>
                        ';
                return $btn;
            })
            ->addColumn('status', function ($row) {
                if($row->status == 0){
                    $status = 'Non Aktif';
                }else{
                    $status = 'Aktif';
                }
                return $status;
            })
            ->rawColumns(['action','status'])
            ->make(true);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $data = array(
            'nama_bank' => $request->nama_bank,
            'no_rek' => $request->no_rek,
            'status' => $request->status
        );

        $insert = Bank::updateOrCreate(
            [
                'id' => $request->id
            ],
            $data
        );

        if($insert){
            $output = array(
                'state' => 200,
                'msg' => 'Sukses'
            );
        }else{
            $output = array(
                'state' => 500,
                'msg' => 'Gagal'
            );
        }

        echo json_encode($output);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $data = Bank::find($id);
        return response()->json($data);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request)
    {
        
    }
}

app/Http/Controllers/Admin/Master/Grade/GradeController.php
<?php

namespace App\Http\Controllers\Admin\Master\Grade;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use DataTables;
use App\Models\Master\Grade;
use App\Models\Master\Jenis;

class GradeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $jenis = Jenis::orderby('nama_jenis','asc')->get();
        return view('admin.master.grade.index',compact('jenis'));
    }

    public function getdata()
    {
        $data = Grade::with('jenis')->get();
        return DataTables::of($data)
            ->addIndexColumn()
            ->addColumn('nama_jenis', function ($row) {
                return $row->jenis->nama_jenis;
            })
            ->addColumn('action', function ($row) {
                $btn = '<button type="button" class="btn btn-warning btn-sm Edit" data-id="' . $row->id . '">
                            <i class="material-icons">mode_edit_outline</i>
                        </button>
                        <button type="button" class="btn btn-sm  btn-danger Delete" data-id="' . $row->id . '">
                            <i class="material-icons">restore_from_trash</i>
                        </button>
                        ';
                return $btn;
            })
            ->rawColumns(['nama_jenis','action'])
            ->make(true);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $data = array(
            'nama_grade' => $request->nama_grade,
            'deskripsi_grade' => $request->deskripsi_grade,
            'jenis_id' => $request->jenis_id
        );

        $insert = Grade::updateOrCreate(
            [
                'id' => $request->id
            ],
            $data
        );

        if($insert){
            $output = array(
                'state' => 200,
                'msg' => 'Sukses'
            );
        }else{
            $output = array(
                'state' => 500,
                'msg' => 'Gagal'
            );
        }

        echo json_encode($output);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $data = Grade::find($id);
        return response()->json($data);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request)
    {
        $delete = Grade::find($request->id)->delete();

        if($delete)
        {
            $output = array(
                'state' => 200,
                'msg' => 'Sukses'
            );

        }else{
            $output = array(
                'state' => 500,
                'msg' => 'Gagal'
            );
        }

        echo json_encode($output);
    }
}

app/Http/Controllers/Admin/Master/Jenis/JenisController.php
<?php

namespace App\Http\Controllers\Admin\Master\Jenis;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use DataTables;
use App\Models\Master\Jenis;


class JenisController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('admin.master.jenis.index');
    }

    public function getdata()
    {
        $data = Jenis::orderby('nama_jenis','asc')->get();
        return DataTables::of($data)
            ->addIndexColumn()
            ->addColumn('action', function ($row) {
                $btn = '<button type="button" class="btn btn-warning btn-sm Edit" data-id="' . $row->id . '">
                            <i class="material-icons">mode_edit_outline</i>
                        </button>
                        <button type="button" class="btn btn-sm  btn-danger Delete" data-id="' . $row->id . '">
                            <i class="material-icons">restore_from_trash</i>
                        </button>
                        ';
                return $btn;
            })
            ->rawColumns(['action'])
            ->make(true);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $data = array(
            'nama_jenis' => $request->nama_jenis
        );

        $insert = Jenis::updateOrCreate(
            [
                'id' => $request->id
            ],
            $data
        );

        if($insert){
            $output = array(
                'state' => 200,
                'msg' => 'Sukses'
            );
        }else{
            $output = array(
                'state' => 500,
                'msg' => 'Gagal'
            );
        }

        echo json_encode($output);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $data = Jenis::find($id);
        return response()->json($data);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request)
    {
        $delete = Jenis::find($request->id)->delete();

        if($delete)
        {
            $output = array(
                'state' => 200,
                'msg' => 'Sukses'
            );

        }else{
            $output = array(
                'state' => 500,
                'msg' => 'Gagal'
            );
        }

        echo json_encode($output);
    }
}

resources/views/admin/master/jenis/index.blade.php
@extends('welcome')

@section('content')

	<div class="row">
        <div class="col">
            <div class="page-description d-flex align-items-center">
                <div class="page-description-content flex-grow-1">
                    <nav aria-label="breadcrumb">
                    <ol class="breadcrumb">
                        <li class="breadcrumb-item">Master</li>
                        <li class="breadcrumb-item" aria-current="page">Jenis</li>
                    </ol>
                </nav>
                </div>
                <div class="page-description-actions">
                    <a href="javascript:void(0)" class="btn btn-primary" id="Add"><i class="material-icons">add</i>Jenis</a>
                </div>
            </div>
        </div>
    </div>

    <div class="row">
        <div class="col">
            <div class="card">
                <div class="card-body">
                    <table id="tbldata" class="display" style="width:100%">
                        <thead>
                            <tr>
                                <th width="5%">No</th>
                                <th width="30%">Nama Jenis</th>
                                <th width="20%">Aksi</th>
                            </tr>
                        </thead>
                        <tbody></tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>

    <!-- Begin::Form Input -->
    <div class="modal fade" id="ModalAdd" tabindex="-1" aria-labelledby="exampleModalCenterTitle" style="display: none; margin-top: 100px;" aria-hidden="true">
        <div class="modal-dialog modal-lg">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="ModalTitle"></h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <form class="row g-3" id="forms">
                        <input type="hidden" id="id">

                        <div class="col-12">
                            <label for="inputAddress" class="form-label">Nama Jenis</label>
                            <input type="text" class="form-control" id="nama_jenis">
                        </div>
                        
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" id="close" data-bs-dismiss="modal">Tutup</button>
                    <button type="button" class="btn btn-primary" id="simpan">Simpan</button>
                </div>
            </div>
        </div>
    </div>
    <!-- End::From Input -->

    <script>

        var table = null;
        table = $('#tbldata').DataTable({
            responsive: true,
            searchDelay: 500,
            processing: true,
            serverSide: true,
            dom: "<'row'<'col-sm-12 col-md-5'l><'col-sm-12 col-md-7 dataTables_pager'f>>rt<'row'<'col-sm-12 col-md-5'i><'col-sm-12 col-md-7 dataTables_pager'p>>",
            lengthMenu: [5, 10, 25, 50],
            pageLength: 10,
            language: {
                'lengthMenu': 'Tampilkan _MENU_',
            },
            order: [[0, 'asc']],
            ajax: "{{ url('admin/master/jenis/getdata') }}",
            columns: [
                {data: 'DT_RowIndex'},
                {data: 'nama_jenis'},
                {data: 'action'}
            ]
            
        });

        $('body').on('click', '#Add', function (e) {
            $('#ModalAdd').modal('show');
            $('#ModalTitle').html('Add');
            $('#forms').trigger("reset");
            $('#id').val('');
        });

        $('body').on('click', '.Edit', function (e) {
            $('#forms').trigger("reset");
            $('#id').val('');
            var id = $(this).data('id');
            $.get("{{ url('admin/master/jenis/edit')}}" +"/"+ id,function(data){

                $('#ModalAdd').modal('show');

                $('#id').val(data.id);
                $('#nama_jenis').val(data.nama_jenis);

            });
        });

        $('body').on('click', '#simpan', function (e) {
            var fd;
            fd = new FormData();
            fd.append('id', $('#id').val());
            fd.append('nama_jenis', $('#nama_jenis').val());
            fd.append('_token', '{{ csrf_token() }}');

            $.ajax({
                data: fd,
                url: "{{ route('Admin.Master.Jenis.store') }}",
                type: "POST",
                dataType: 'json',
                processData: false,
                contentType: false,
                beforeSend: function() {
                    $('#simpan').html('<span class="spinner-grow spinner-grow-sm" role="status"></span> Loading...');
                    $('#simpan').prop("disabled",true);
                    $('#close').prop("disabled",true);
                },
                success: function (data) {

                    if(data.state == '200'){
                        Swal.fire(data.msg, "", "success");
                        $('#ModalAdd').modal('hide');
                    }else{
                        Swal.fire(data.msg, "", "error");
                    }
                    table.draw();

                },
                error: function (data) {
                    $('#simpan').html('<i class="icon-sm fas fa-save"></i> Simpan');
                    $('#simpan').prop("disabled",false);
                    $('#close').prop("disabled",false);
                    console.log(data);
                },
                complete: function() {
                    $('#simpan').html('<i class="icon-sm fas fa-save"></i> Simpan');
                    $('#simpan').prop("disabled",false);
                    $('#close').prop("disabled",false);
                }
            });

        });

        $('body').on('click', '.Delete', function (e) {
            var id = $(this).data('id');
            Swal.fire({
                title: "Anda yakin ?",
                icon: "question",
                showCancelButton: true,
            }).then(function(result) {
                if (result.value) {
                    var fd;
                    fd = new FormData();
                    fd.append('id', id);
                    fd.append('_token', '{{ csrf_token() }}');

                    $.ajax({
                        data: fd,
                        url: "{{ route('Admin.Master.Jenis.destroy') }}",
                        type: "POST",
                        dataType: 'json',
                        processData: false,
                        contentType: false,
                        success: function (data) {

                            if(data.state == '200'){
                                Swal.fire(data.msg, "", "success");
                            }else{
                                Swal.fire(data.msg, "", "error");
                            }
                            table.draw();

                        },
                        error: function (data) {
                            console.log(data);
                        },
                        complete: function() {
                        }
                    });
                }
            });
        });


    </script>

@endsection